SystemOrganization addCategory: #'EjerciciosPoo-TusLibros'!

Error subclass: #CanNotAddABookFromOtherEditorialToACart
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-TusLibros'!

Error subclass: #CanNotAddABookWithAmountLessThanOne
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-TusLibros'!

Object subclass: #Book
	instanceVariableNames: 'editorial isbn price'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-TusLibros'!

!Book class methodsFor: 'as yet unclassified' stamp: 'IgalFrid 6/13/2012 17:00'!
newWithIsbn: anIsbn price: aPrice

	^Book new initializeWithIsbn: anIsbn price: aPrice! !

!Book methodsFor: 'as yet unclassified' stamp: 'IgalFrid 6/13/2012 17:02'!
initializeWithIsbn: anIsbn price: aPrice

	isbn := anIsbn.
	price := aPrice.! !

!Book methodsFor: 'as yet unclassified' stamp: 'IgalFrid 6/13/2012 17:03'!
isbn
	
	^isbn! !

!Book methodsFor: 'as yet unclassified' stamp: 'IgalFrid 6/13/2012 17:04'!
price
	
	^price! !

Object subclass: #Cart
	instanceVariableNames: 'acceptedBooks contents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-TusLibros'!

!Cart class methodsFor: 'as yet unclassified' stamp: 'IgalFrid 6/11/2012 18:46'!
newWithListOfAcceptedBooks: aListOfAcceptedBooks
	
	^self new initializeWithListOfAcceptedBooks: aListOfAcceptedBooks! !

!Cart methodsFor: 'as yet unclassified' stamp: 'IgalFrid 6/13/2012 17:24'!
add: aBook
	
	self verifyIfABook: aBook IsFromEditorialAndDo: [contents add: aBook]! !

!Cart methodsFor: 'as yet unclassified' stamp: 'IgalFrid 6/13/2012 17:25'!
add: aBook amount: anInteger
	
	(anInteger > 0)
	ifTrue: [self verifyIfABook: aBook IsFromEditorialAndDo: [contents add: aBook withOccurrences: anInteger]]
	ifFalse: [CanNotAddABookWithAmountLessThanOne signal: 'No se puede agregar un libro con cantidades negativas']! !

!Cart methodsFor: 'as yet unclassified' stamp: 'IgalFrid 6/13/2012 17:33'!
amountOf: aTitle
	
	^contents occurrencesOf: aTitle! !

!Cart methodsFor: 'as yet unclassified' stamp: 'IgalFrid 6/13/2012 18:00'!
books
	
	| books |
	
	books := Set new.
	
	contents do: [:book | books add: book isbn].
	
	^books! !

!Cart methodsFor: 'as yet unclassified' stamp: 'IgalFrid 6/13/2012 18:02'!
contents
	
	^contents! !

!Cart methodsFor: 'as yet unclassified' stamp: 'IgalFrid 6/11/2012 18:47'!
initializeWithListOfAcceptedBooks: aListOfAcceptedBooks

	acceptedBooks := aListOfAcceptedBooks.
	contents := Bag new.! !

!Cart methodsFor: 'as yet unclassified' stamp: 'IgalFrid 6/11/2012 18:55'!
isEmpty 
	
	^contents isEmpty ! !

!Cart methodsFor: 'as yet unclassified' stamp: 'IgalFrid 6/13/2012 18:18'!
totalAmount
	
	| total |
	
	total := 0.
	
	contents do: [:isbn | total := total + (acceptedBooks detect: [:book | book isbn = isbn]) price].
	
	^total! !

!Cart methodsFor: 'as yet unclassified' stamp: 'IgalFrid 6/13/2012 17:40'!
verifyIfABook: aBook IsFromEditorialAndDo: aBlock
	
	((acceptedBooks select: [:book | book isbn = aBook]) size = 1) 
		ifTrue: aBlock
		ifFalse: [CanNotAddABookFromOtherEditorialToACart signal: 'No se puede agregar un libro de otra editorial']! !

TestCase subclass: #TusLibrosTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-TusLibros'!

!TusLibrosTest methodsFor: 'books' stamp: 'IgalFrid 6/13/2012 17:38'!
book1FromEditorial1 

	^'Book10'! !

!TusLibrosTest methodsFor: 'books' stamp: 'IgalFrid 6/13/2012 17:38'!
book2FromEditorial1 

	^'Book11'! !

!TusLibrosTest methodsFor: 'books' stamp: 'IgalFrid 6/13/2012 17:42'!
bookFromEditorial2 

	^'Book20'! !

!TusLibrosTest methodsFor: 'errors' stamp: 'IgalFrid 6/8/2012 17:45'!
canNotAddABookFromOtherEditorialToACart
	
	^CanNotAddABookFromOtherEditorialToACart! !

!TusLibrosTest methodsFor: 'errors' stamp: 'IgalFrid 6/13/2012 17:18'!
canNotAddABookWithAmountLessThanOne 
	
	^CanNotAddABookWithAmountLessThanOne! !

!TusLibrosTest methodsFor: 'carts' stamp: 'IgalFrid 6/11/2012 18:54'!
cartFromEditorial1 
	
	^Cart newWithListOfAcceptedBooks: self listOfBooks1.! !

!TusLibrosTest methodsFor: 'carts' stamp: 'IgalFrid 6/11/2012 18:54'!
cartFromEditorial2 
	
	^Cart newWithListOfAcceptedBooks: self listOfBooks2.! !

!TusLibrosTest methodsFor: 'carts' stamp: 'IgalFrid 6/13/2012 17:58'!
cartWithTwoBooksFromEditorial1 
	
	| cart |
	
	cart := Cart newWithListOfAcceptedBooks: self listOfBooks1.
	cart add: self book1FromEditorial1 amount: 4.
	cart add: self book2FromEditorial1 amount: 3.
	
	^cart! !

!TusLibrosTest methodsFor: 'books' stamp: 'IgalFrid 6/13/2012 17:46'!
listOfBooks1
	| books |
	
	books := Set new.
	books add: (Book newWithIsbn:'Book10' price: 10); add: (Book newWithIsbn:'Book11' price: 20).
	^books! !

!TusLibrosTest methodsFor: 'books' stamp: 'IgalFrid 6/13/2012 17:47'!
listOfBooks2
	| books |
	
	books := Set new.
	books add: (Book newWithIsbn:'Book20' price: 5); add: (Book newWithIsbn:'Book21' price: 7).
	^books! !

!TusLibrosTest methodsFor: '1 - Test cart' stamp: 'IgalFrid 6/8/2012 17:07'!
test01NewCartShouldBeEmpty

	self assert: self cartFromEditorial1 isEmpty! !

!TusLibrosTest methodsFor: '1 - Test cart' stamp: 'IgalFrid 6/13/2012 17:37'!
test02CanAddABookFromTheSameEditorialOfTheCart

	| cart |
	
	cart := self cartFromEditorial1.
	cart add: self book1FromEditorial1.
	self deny: cart isEmpty! !

!TusLibrosTest methodsFor: '1 - Test cart' stamp: 'IgalFrid 6/13/2012 17:08'!
test03CannotAddABookFromOtherEditorialToACart

	self should: [ self cartFromEditorial1 add: self bookFromEditorial2] raise: self canNotAddABookFromOtherEditorialToACart.! !

!TusLibrosTest methodsFor: '1 - Test cart' stamp: 'IgalFrid 6/13/2012 17:37'!
test04CanAddABookWithAmountPositiveToACart

	| cart |
	
	cart := self cartFromEditorial1.
	cart add: self book1FromEditorial1 amount: 2.
	self deny: cart isEmpty ! !

!TusLibrosTest methodsFor: '1 - Test cart' stamp: 'IgalFrid 6/13/2012 17:15'!
test05CannotAddABookWithAmountFromOtherEditorialToACart

	self should: [ self cartFromEditorial1 add: self bookFromEditorial2 amount: 2] raise: self canNotAddABookFromOtherEditorialToACart.! !

!TusLibrosTest methodsFor: '1 - Test cart' stamp: 'IgalFrid 6/13/2012 17:37'!
test06CannotAddABookWithAmountLessThanOneToACart

	self should: [ self cartFromEditorial1 add: self book1FromEditorial1 amount: 0] raise: self canNotAddABookWithAmountLessThanOne.
	self should: [ self cartFromEditorial1 add: self book1FromEditorial1 amount: -2] raise: self canNotAddABookWithAmountLessThanOne.! !

!TusLibrosTest methodsFor: '1 - Test cart' stamp: 'IgalFrid 6/13/2012 17:34'!
test07AmountOfBooksOfANotExistsBook

	self assert: (self cartFromEditorial1 amountOf: 'Book10') = 0 
! !

!TusLibrosTest methodsFor: '1 - Test cart' stamp: 'IgalFrid 6/13/2012 17:50'!
test08AmountOfBooksAddedPerOne

	| cart |
	
	cart := self cartFromEditorial1.
	cart add: self book1FromEditorial1.
	self assert: (cart amountOf: self book1FromEditorial1) = 1. 
 
	cart add: self book1FromEditorial1.
	self assert: (cart amountOf: self book1FromEditorial1) = 2 
 ! !

!TusLibrosTest methodsFor: '1 - Test cart' stamp: 'IgalFrid 6/13/2012 17:52'!
test09AmountOfBooksAddedWithAmounts

	| cart |
	
	cart := self cartFromEditorial1.
	cart add: self book1FromEditorial1 amount: 4.
	self assert: (cart amountOf: self book1FromEditorial1) = 4. 
 
	cart add: self book1FromEditorial1 amount: 3.
	self assert: (cart amountOf: self book1FromEditorial1) = 7 
 ! !

!TusLibrosTest methodsFor: '1 - Test cart' stamp: 'IgalFrid 6/13/2012 18:07'!
test10CartCorrectlyListItsRequestedBooks

	| books|
	
	books := Bag new.
	books add: self book1FromEditorial1 withOccurrences: 4.
	books add: self book2FromEditorial1 withOccurrences: 3.
	
	self assert: (self cartWithTwoBooksFromEditorial1 contents) = books 
 ! !

!TusLibrosTest methodsFor: '1 - Test cart' stamp: 'IgalFrid 6/13/2012 18:10'!
test11TotalAmountOfANewCartShouldBeZero
	
	self assert: (self cartFromEditorial1 totalAmount) = 0 
 ! !

!TusLibrosTest methodsFor: '1 - Test cart' stamp: 'IgalFrid 6/13/2012 18:13'!
test12TotalAmountOfACartWithContentsShouldReturnCorrectlyTheTotalAmount
	
	self assert: (self cartWithTwoBooksFromEditorial1 totalAmount) = 100 
 ! !
